Create an environment

POST https://api.ap1.datadoghq.com/api/v2/feature-flags/environmentshttps://api.ap2.datadoghq.com/api/v2/feature-flags/environmentshttps://api.datadoghq.eu/api/v2/feature-flags/environmentshttps://api.ddog-gov.com/api/v2/feature-flags/environmentshttps://api.us2.ddog-gov.com/api/v2/feature-flags/environmentshttps://api.datadoghq.com/api/v2/feature-flags/environmentshttps://api.us3.datadoghq.com/api/v2/feature-flags/environmentshttps://api.us5.datadoghq.com/api/v2/feature-flags/environments

Overview

Creates a new environment for organizing feature flags. This endpoint requires the feature_flag_environment_config_write permission.

Request

Body Data (required)

Expand All

Field

Type

Description

data [required]

object

Data for creating a new environment.

attributes [required]

object

Attributes for creating a new environment.

is_production

boolean

Indicates whether this is a production environment.

name [required]

string

The name of the environment.

queries [required]

[string]

List of queries to define the environment scope.

require_feature_flag_approval

boolean

Indicates whether feature flag changes require approval in this environment.

type [required]

enum

The resource type. Allowed enum values: environments

{
  "data": {
    "type": "environments",
    "attributes": {
      "name": "Test Environment Example-Feature-Flag",
      "queries": [
        "test-Example-Feature-Flag",
        "env-Example-Feature-Flag"
      ]
    }
  }
}

Response

Created

Response containing an environment.

Expand All

Field

Type

Description

data [required]

object

A feature flag environment resource.

attributes [required]

object

Attributes of an environment.

created_at

date-time

The timestamp when the environment was created.

description

string

The description of the environment.

is_production

boolean

Indicates whether this is a production environment.

key

string

The unique key of the environment.

name [required]

string

The name of the environment.

queries

[string]

List of queries to define the environment scope.

require_feature_flag_approval

boolean

Indicates whether feature flag changes require approval in this environment.

updated_at

date-time

The timestamp when the environment was last updated.

id [required]

uuid

The unique identifier of the environment.

type [required]

enum

The resource type. Allowed enum values: environments

{
  "data": {
    "attributes": {
      "created_at": "2023-01-01T00:00:00Z",
      "description": "Test environment XYZ789",
      "is_production": false,
      "key": "env-search-term",
      "name": "env-search-term",
      "queries": [
        "staging",
        "test"
      ],
      "require_feature_flag_approval": false,
      "updated_at": "2023-01-01T00:00:00Z"
    },
    "id": "550e8400-e29b-41d4-a716-446655440001",
    "type": "environments"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Forbidden

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Conflict

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                          ## default
# 

# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/feature-flags/environments" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "name": "staging-environment", "queries": [ "staging", "canary" ] }, "type": "environments" } } EOF
// Create an environment returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.CreateEnvironmentRequest{
		Data: datadogV2.CreateEnvironmentData{
			Type: datadogV2.CREATEENVIRONMENTDATATYPE_ENVIRONMENTS,
			Attributes: datadogV2.CreateEnvironmentAttributes{
				Name: "Test Environment Example-Feature-Flag",
				Queries: []string{
					"test-Example-Feature-Flag",
					"env-Example-Feature-Flag",
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewFeatureFlagsApi(apiClient)
	resp, r, err := api.CreateFeatureFlagsEnvironment(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `FeatureFlagsApi.CreateFeatureFlagsEnvironment`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `FeatureFlagsApi.CreateFeatureFlagsEnvironment`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
// Create an environment returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.FeatureFlagsApi;
import com.datadog.api.client.v2.model.CreateEnvironmentAttributes;
import com.datadog.api.client.v2.model.CreateEnvironmentData;
import com.datadog.api.client.v2.model.CreateEnvironmentDataType;
import com.datadog.api.client.v2.model.CreateEnvironmentRequest;
import com.datadog.api.client.v2.model.EnvironmentResponse;
import java.util.Arrays;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    FeatureFlagsApi apiInstance = new FeatureFlagsApi(defaultClient);

    CreateEnvironmentRequest body =
        new CreateEnvironmentRequest()
            .data(
                new CreateEnvironmentData()
                    .type(CreateEnvironmentDataType.ENVIRONMENTS)
                    .attributes(
                        new CreateEnvironmentAttributes()
                            .name("Test Environment Example-Feature-Flag")
                            .queries(
                                Arrays.asList(
                                    "test-Example-Feature-Flag", "env-Example-Feature-Flag"))));

    try {
      EnvironmentResponse result = apiInstance.createFeatureFlagsEnvironment(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FeatureFlagsApi#createFeatureFlagsEnvironment");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
"""
Create an environment returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.feature_flags_api import FeatureFlagsApi
from datadog_api_client.v2.model.create_environment_attributes import CreateEnvironmentAttributes
from datadog_api_client.v2.model.create_environment_data import CreateEnvironmentData
from datadog_api_client.v2.model.create_environment_data_type import CreateEnvironmentDataType
from datadog_api_client.v2.model.create_environment_request import CreateEnvironmentRequest

body = CreateEnvironmentRequest(
    data=CreateEnvironmentData(
        type=CreateEnvironmentDataType.ENVIRONMENTS,
        attributes=CreateEnvironmentAttributes(
            name="Test Environment Example-Feature-Flag",
            queries=[
                "test-Example-Feature-Flag",
                "env-Example-Feature-Flag",
            ],
        ),
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = FeatureFlagsApi(api_client)
    response = api_instance.create_feature_flags_environment(body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
# Create an environment returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::FeatureFlagsAPI.new

body = DatadogAPIClient::V2::CreateEnvironmentRequest.new({
  data: DatadogAPIClient::V2::CreateEnvironmentData.new({
    type: DatadogAPIClient::V2::CreateEnvironmentDataType::ENVIRONMENTS,
    attributes: DatadogAPIClient::V2::CreateEnvironmentAttributes.new({
      name: "Test Environment Example-Feature-Flag",
      queries: [
        "test-Example-Feature-Flag",
        "env-Example-Feature-Flag",
      ],
    }),
  }),
})
p api_instance.create_feature_flags_environment(body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
// Create an environment returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_feature_flags::FeatureFlagsAPI;
use datadog_api_client::datadogV2::model::CreateEnvironmentAttributes;
use datadog_api_client::datadogV2::model::CreateEnvironmentData;
use datadog_api_client::datadogV2::model::CreateEnvironmentDataType;
use datadog_api_client::datadogV2::model::CreateEnvironmentRequest;

#[tokio::main]
async fn main() {
    let body = CreateEnvironmentRequest::new(CreateEnvironmentData::new(
        CreateEnvironmentAttributes::new(
            "Test Environment Example-Feature-Flag".to_string(),
            vec![
                "test-Example-Feature-Flag".to_string(),
                "env-Example-Feature-Flag".to_string(),
            ],
        ),
        CreateEnvironmentDataType::ENVIRONMENTS,
    ));
    let configuration = datadog::Configuration::new();
    let api = FeatureFlagsAPI::with_config(configuration);
    let resp = api.create_feature_flags_environment(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Create an environment returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.FeatureFlagsApi(configuration);

const params: v2.FeatureFlagsApiCreateFeatureFlagsEnvironmentRequest = {
  body: {
    data: {
      type: "environments",
      attributes: {
        name: "Test Environment Example-Feature-Flag",
        queries: ["test-Example-Feature-Flag", "env-Example-Feature-Flag"],
      },
    },
  },
};

apiInstance
  .createFeatureFlagsEnvironment(params)
  .then((data: v2.EnvironmentResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"